<%@ language=javascript %>
<%Response.Buffer = true;
Response.ContentType = "text/xml";
/*
This is a small SOAP service for HTML Tidy. It expects you to send a VALID SOAP packet
with only one element which has the HTML to be cleaned.
Note that this html should only be the ones within the body tags. It will
clean the html, and send the cleaned html back as a similar SOAP packet.

S Babu - 2001.04.25
*/
var objTidy, txt_html, out_html;
var lock_file = "tidy.lck";
var tidy_cfg = "tidy.cfg"; //Tidy configuration file
var fso,fp;
var wait=5; //how long to wait till the lock is force-cleared
var xmldom, xmlhttp;
/* Utility function. Returns only the body part of an HTML document */
function getBody(strHTML){
	var strOUT = new String(strHTML);
	/*
	In case you are wondering, I'm not able to get regex to match a multiline
	string. So, I first convert all new lines to a magic string, which is now
	"Nammude_Pagilillatha_Sadhanam" which in Malayalam  means 
	"Something_not_present_in_our_page".
	Then I get the stuff between body tags, convert the magic string back to
	new line.
	*/
	strOUT = strHTML.replace(/\n/g, "Nammude_Pagilillatha_Sadhanam");
	strOUT = strOUT.replace(/^(.*)<body>(.*)<\/body>(.*)$/gi, "$2");
	strOUT = strOUT.replace(/Nammude_Pagilillatha_Sadhanam/g, "\n");
	return(strOUT);
}

xmldom = Server.CreateObject("Microsoft.XMLDOM");
xmlhttp = Server.CreateObject("Microsoft.XMLHTTP");
xmldom.load(Request);

txt_html = xmldom.documentElement.childNodes.item(0).childNodes.item(0).text;

if (txt_html != "" ) {
	/* rudimentary lock processing  - tidy object is non re-entrant so only one instance should be running
	   at any given time
	*/
	out_html="<html><head><title>Hello</title><body>" + txt_html +"</body></html>";
	fso = Server.CreateObject("Scripting.FileSystemObject");
	while(fso.FileExists(Server.MapPath(lock_file))){
		/* sleep for some time and check again */
		wait--;
		if(wait<=0){
			fso.DeleteFile(Server.MapPath(lock_file));
			break;
		} else { // a delay
			for(i=0;i<=1000;i++);
		}
	}
	//create a new lock file
	fp = fso.CreateTextFile(Server.MapPath(lock_file),true);
	fp.WriteLine("This is locked");
	fp.Close();
	fp = null;

	//tidy the document
	objTidy = Server.CreateObject("TidyCOM.TidyObject");
	objTidy.Options.Load(Server.MapPath(tidy_cfg));
	out_html = objTidy.TidyMemToMem(out_html);
	out_html = getBody(out_html);

	//cleanup
	objTidy = null;

	//delete the lock file
	fso.DeleteFile(Server.MapPath(lock_file));
	fso = null;
} else {
	out_html = "";
}
responseXML  = '<SOAP:Envelope xmlns:SOAP="urn:schemas-xmlsoap-org:soap.v1">';
responseXML  += "<SOAP:Body>";
responseXML  += "<message>";
responseXML  += "<cleanhtml><![CDATA[" + out_html + "]]></cleanhtml>";
responseXML  += "</message>";
responseXML  += "</SOAP:Body>";
responseXML  += "</SOAP:Envelope>";
Response.Write(responseXML);
txt_html = null;
out_html = null;
responseXML = null;
xmldom = null;
xmlhttp = null;
%>
